︠24ea9e9c-2c63-4155-8f00-67687f09f46ci︠
%hide
%md

# Rates of Change

The average speed of a moving object over some time interval is the distance
between positions divided by the time it took to get from one position to the
next. More generally, the average rate of change of a function of time is the
change in the value of the function divided by the length of the time interval.
︡cac8da34-0710-41de-b63a-7e076f6d2d27︡{"hide":"input"}︡{"md":"\n# Rates of Change\n\nThe average speed of a moving object over some time interval is the distance\nbetween positions divided by the time it took to get from one position to the\nnext. More generally, the average rate of change of a function of time is the\nchange in the value of the function divided by the length of the time interval."}︡{"done":true}
︠3bfc9145-cf5e-4493-a3a1-ab40adf888b6s︠
# Code for weird_function(), which will be used in the following exercise:
def weird_function():
    pieces = [sin(x), cos(x), arctan(x), ln(x), sqrt(x), exp(x)]
    f(x)=prod([choice(pieces) for i in srange(5)]) + prod([choice(pieces) for i in srange(5)])
    return f
︡a4fbf0ad-6a54-4d3d-90ef-385ae8806a0a︡{"done":true}
︠f46d2cc8-cd83-4944-8daf-677889c05b00si︠
%hide
%md
${\bf Exercise\; 1.}$ Evaluate the cell in your turn-in sheet that contains the function
${\bf weird\_function()}$ and run the command ${\bf h(x)=weird\_function()}$ to create a
random function called $h(x)$.
︡8dedb516-2d6c-4c58-b8c4-131ddec887b3︡{"hide":"input"}︡{"md":"${\\bf Exercise\\; 1.}$ Evaluate the cell in your turn-in sheet that contains the function\n${\\bf weird\\_function()}$ and run the command ${\\bf h(x)=weird\\_function()}$ to create a\nrandom function called $h(x)$."}︡{"done":true}
︠070efe31-2565-41ab-91bd-fc50136035d9s︠
h(x)=5*x+2
︡ab715cad-e6b7-4223-9c83-4ea4037a53ea︡{"done":true}
︠5f548897-c18f-48e5-a3e2-020029ed5f28i︠
%hide
%md

${\bf Exercise \; 2.}$ Compute the average rate of change of $h(x)$ between $x = 3.5$ and
$x = 5.5.$
︡3e5520cd-bd79-4e0c-b79c-0064746324dd︡{"hide":"input"}︡{"md":"\n${\\bf Exercise \\; 2.}$ Compute the average rate of change of $h(x)$ between $x = 3.5$ and\n$x = 5.5.$"}︡{"done":true}
︠7cb990b7-fe12-4e6d-aa1f-2a9086f5e726s︠
(h(5.5)-h(3.5))/2
︡c424a2a6-29fe-442a-87ac-082e44474bf6︡{"stdout":"5.00000000000000\n"}︡{"done":true}
︠72945deb-4aca-4109-967d-616186500d31i︠

%hide
%md

We know the average rate of change of the function between $x = 3.5$ and
$x = 5.5$. Now, we want its rate of change at $x = 3.5$.

${\bf Exercise \;3.}$ Create a list of average rates of change for $h(x)$ for $\Delta x$ values of
1, 0.1, 0.01, and 0.001. (You can do this by hand or use a loop.) Use the result
to estimate the function’s rate of change at $x = 3.5$. Why do you think the
number you gave is the rate of change at that value of $x$?
︡8a0d831c-af57-4490-9a38-ee8245db129a︡{"hide":"input"}︡{"md":"\nWe know the average rate of change of the function between $x = 3.5$ and\n$x = 5.5$. Now, we want its rate of change at $x = 3.5$.\n\n${\\bf Exercise \\;3.}$ Create a list of average rates of change for $h(x)$ for $\\Delta x$ values of\n1, 0.1, 0.01, and 0.001. (You can do this by hand or use a loop.) Use the result\nto estimate the function’s rate of change at $x = 3.5$. Why do you think the\nnumber you gave is the rate of change at that value of $x$?"}︡{"done":true}
︠fee31ebe-ae72-4ff1-bccd-231812c82d02s︠
dx_list=[1,0.1,0.01,0.001]
ave_change_list=[]
for dx in dx_list:
    ave_change=(h(3.5+dx)-h(3.5))/dx
    ave_change_list.append(ave_change)
ave_change_list
︡6dab2757-12c7-4351-808c-571813629701︡{"stdout":"[5.00000000000000, 5.00000000000000, 4.99999999999972, 4.99999999999901]\n"}︡{"done":true}
︠72da219e-a975-4cba-8227-eebf06b5a529i︠
%hide
%md
The rate of change of a function at a point is called its instantaneous rate
of change at that point.

${\bf Exercise\; 4.}$ Estimate the instantaneous rate of change at another point (as
you did in Exercise 3).
︡c5b93529-601b-4e96-8871-0fed95163cbb︡{"hide":"input"}︡{"md":"The rate of change of a function at a point is called its instantaneous rate\nof change at that point.\n\n${\\bf Exercise\\; 4.}$ Estimate the instantaneous rate of change at another point (as\nyou did in Exercise 3)."}︡{"done":true}
︠f4b7271e-efef-4779-95fb-4abf0deb6f69s︠
x0=2.
dx_list=[1,0.1,0.01,0.001,0.0001,0.00001,0.000001,0.0000001]
ave_change_list=[]
for dx in dx_list:
    ave_change=(h(x0+dx)-h(x0))/dx
    ave_change_list.append(ave_change)
ave_change_list
︡7dbe4eb1-e549-42f9-b519-c83033386954︡{"stdout":"[5.00000000000000, 5.00000000000000, 4.99999999999989, 4.99999999999901, 5.00000000000611, 4.99999999998835, 5.00000000158707, 4.99999998737621]\n"}︡{"done":true}
︠45781a63-8879-45be-81c0-8ff2a45af18dis︠
%hide
%md

At this point, you might be wondering why we bother with different values
of $\Delta x$ at all. Why not just pick a small value of $\Delta x$ and always use that to
compute rates of change? The answer won’t be mathematically precise, but
real-world measurements always have some error anyway. The following series
of exercises will explore this question.

${\bf Exercise\; 5.}$ Find the average rates of change for the function $f(t) = t^3-3t^2+4t+1$
at $t = 1$ using 1, 0.1, 0.01, and 0.001 as your values of $\Delta t$. Then, estimate the
function’s rate of change at $t = 1$. Feel free to use more $\Delta t$ values if you want.
︡5513158a-8777-4b83-bed7-964d72b2f4b8︡{"hide":"input"}︡{"md":"\nAt this point, you might be wondering why we bother with different values\nof $\\Delta x$ at all. Why not just pick a small value of $\\Delta x$ and always use that to\ncompute rates of change? The answer won’t be mathematically precise, but\nreal-world measurements always have some error anyway. The following series\nof exercises will explore this question.\n\n${\\bf Exercise\\; 5.}$ Find the average rates of change for the function $f(t) = t^3-3t^2+4t+1$\nat $t = 1$ using 1, 0.1, 0.01, and 0.001 as your values of $\\Delta t$. Then, estimate the\nfunction’s rate of change at $t = 1$. Feel free to use more $\\Delta t$ values if you want."}︡{"done":true}
︠02ef0685-4eff-4050-98aa-731ba69afc9cs︠
var('t')
f(t)=t^3-3*t^2+4*t^1
t0=1.
dt_list=[1,0.1,0.01,0.001,0.0001,0.00001]
ave_change_list=[]
for dt in dt_list:
    ave_change=(f(t0+dt)-f(t0))/dt
    ave_change_list.append(ave_change)
ave_change_list
︡9422d90a-b9c2-4c80-9e95-49ccb5e816c4︡{"stdout":"t\n"}︡{"stdout":"[2.00000000000000, 1.01000000000000, 1.00010000000004, 1.00000100000042, 1.00000000999856, 1.00000000009537]\n"}︡{"done":true}
︠4e782bb1-8baa-4e9b-a5d2-2f36a0e5d3c2is︠

%hide
%md

${\bf Exercise\; 6.}$ Repeat this procedure for $g(t) = t^3-4t^2+6t+2$. What is this function’s
rate of change at $t = 1$?
︡f670cddb-923d-4353-90d0-bbbdcca61a2a︡{"hide":"input"}︡{"md":"\n${\\bf Exercise\\; 6.}$ Repeat this procedure for $g(t) = t^3-4t^2+6t+2$. What is this function’s\nrate of change at $t = 1$?"}︡{"done":true}
︠19bf13c4-cbd3-4dc6-b7dc-d6f248938ef2s︠
var('t')
g(t)=t^3-4*t^2+6*t+2
t0=1.
dt_list=[1,0.1,0.01,0.001,0.0001,0.00001]
ave_change_list=[]
for dt in dt_list:
    ave_change=(f(t0+dt)-f(t0))/dt
    ave_change_list.append(ave_change)
ave_change_list
︡02732b0d-395c-4362-b643-6c2dddeed3e2︡{"stdout":"t\n"}︡{"stdout":"[2.00000000000000, 1.01000000000000, 1.00010000000004, 1.00000100000042, 1.00000000999856, 1.00000000009537]\n"}︡{"done":true}
︠1a0fac6e-bcf0-4ae8-b587-5c2f8f8e0c38i︠
%hide
%md
${\bf Exercise\; 7.}$ Drawing on your results, briefly explain why limits are necessary
when computing derivatives. Why don’t we just pick a small value of $\Delta t$ and
always use that?
︡617a7f51-ec0f-4a92-b21f-63a1b9601b88︡{"hide":"input"}︡{"md":"${\\bf Exercise\\; 7.}$ Drawing on your results, briefly explain why limits are necessary\nwhen computing derivatives. Why don’t we just pick a small value of $\\Delta t$ and\nalways use that?"}︡{"done":true}
︠22a6ce9e-6543-45c8-a89c-cf80ba720b11︠
#limits are necessary because the approximation goes on to infinity and using a very, very small number/big decimal isn't ethical  when a certain limit can be drawn at a certain good approximation. 
︡e2d2ec72-3784-4061-93d9-63796800439e︡{"done":true}
︠bba47518-3a56-4900-898b-2f4911f0a12di︠
%hide
%md
## Symbolic Calculations in Sage

One of Sage’s most powerful features is its ability to do symbolic computations
– calculations with variables rather than numbers. Such calculations require
you to use a particular kind of variable called a symbolic variable. Symbolic
variables can be manipulated algebraically without having numerical values.
The variable x is a built-in symbolic variable.
︡89a0cd25-1d13-4abc-8992-f2bf54cdd706︡{"hide":"input"}︡{"md":"## Symbolic Calculations in Sage\n\nOne of Sage’s most powerful features is its ability to do symbolic computations\n– calculations with variables rather than numbers. Such calculations require\nyou to use a particular kind of variable called a symbolic variable. Symbolic\nvariables can be manipulated algebraically without having numerical values.\nThe variable x is a built-in symbolic variable."}︡{"done":true}
︠7f916236-ff6e-40d4-aeb4-6ce5c892ab97︠

(x^5)/(x^3)

︡6649fce3-08c6-4a79-9f4e-8e317c73cfc8︡{"stdout":"x^2\n"}︡{"done":true}
︠999ae22c-f205-49e6-9950-53ba500dce36i︠
%hide
%md

${\bf Exercise\; 8.}$ Compute $x^3x^7$.
︡20b3e660-368c-4f02-8cf3-49d4e2d9fcb0︡{"hide":"input"}︡{"md":"\n${\\bf Exercise\\; 8.}$ Compute $x^3x^7$."}︡{"done":true}
︠847374d4-6f5f-42df-8d6e-dd836d8025f3s︠
x^3*x^7
︡f62f9b82-8366-464f-b703-c68c4a410660︡{"stdout":"x^10\n"}︡{"done":true}
︠94889536-d75b-45e3-86ce-2e4afd18e73bi︠
%hide
%md

${\bf Exercise\; 9.}$ Find the type of $x$.
︡32fa1a78-d4f9-4bd6-8a8a-0c6a152eb197︡{"hide":"input"}︡{"md":"\n${\\bf Exercise\\; 9.}$ Find the type of $x$."}︡{"done":true}
︠5ae8eaee-e93c-48f6-95ee-a506eb3b3074s︠
type(x)
︡e70f7de0-e990-4858-845b-0784422ec6f9︡{"stdout":"<type 'sage.symbolic.expression.Expression'>\n"}︡{"done":true}
︠20254ee1-6577-437f-b521-3ee3a57f1896is︠
%hide
%md
The variable $x$ is a built-in symbolic variable. To use other symbolic variables,
like $N$ or $P$, you’ll need to create them. This is called declaring the
variables and is done using the var function. This function takes a string of
variable names, separated by commas, as input and generates the appropriate
symbolic variables.
︡744dfa47-7454-4dac-b376-c4144d37cee4︡{"hide":"input"}︡{"md":"The variable $x$ is a built-in symbolic variable. To use other symbolic variables,\nlike $N$ or $P$, you’ll need to create them. This is called declaring the\nvariables and is done using the var function. This function takes a string of\nvariable names, separated by commas, as input and generates the appropriate\nsymbolic variables."}︡{"done":true}
︠27c17605-0333-4e74-bb74-fa5af908b576︠
var("a")

︡7c8ab4ec-1a47-4c80-8a90-dd63b6904a36︡{"stdout":"a\n"}︡{"done":true}
︠e425db06-c2f4-460e-8dea-aba7eb45de4f︠
(a^3)/a

︡1835cd90-3a5f-4cca-84c0-bc1fcc421c38︡{"stdout":"a^2\n"}︡{"done":true}
︠f71fec23-01d3-44d3-890a-24333a6c4109i︠
%hide
%md

Note that Sage assumes that $a \neq 0$.
Symbolic variables don’t have to be single letters.
︡6aaa3165-a8ef-417e-8b10-e1668f8d91e0︡{"hide":"input"}︡{"md":"\nNote that Sage assumes that $a \\neq 0$.\nSymbolic variables don’t have to be single letters."}︡{"done":true}
︠77e254b7-1e0c-430c-b42b-edc4fdfaddd9︠
var("sheep, rabbits")

︡47b65211-cd9b-4074-b882-b0ab73c785a1︡{"stdout":"(sheep, rabbits)\n"}︡{"done":true}
︠729a4388-0a7b-4b1c-b19c-e90903f697ab︠
2*sheep+3*rabbits

︡ea4cef68-31eb-4d58-9264-84e4745beb03︡{"stdout":"3*rabbits + 2*sheep\n"}︡{"done":true}
︠035d0398-bc11-45cb-8767-6c1c56fc0167i︠
%hide
%md

Once a symbolic variable has been declared, you can use it in subsequent
calculations without re-declaring it until you close your worksheet.
︡4a0ddade-bc47-490f-9bf6-a4abf865b493︡{"hide":"input"}︡{"md":"\nOnce a symbolic variable has been declared, you can use it in subsequent\ncalculations without re-declaring it until you close your worksheet."}︡{"done":true}
︠7107e494-63a5-4f80-a259-eadefabd83ca︠
a*a

︡7bcb5d44-14d1-4060-9df1-efc501fe39e3︡{"stdout":"a^2\n"}︡{"done":true}
︠148c36fb-991f-4b62-bcf8-a43b37899b18is︠
%hide
%md

The command **factor** allows you to factor polynomials.
︡a3cae7f2-d0dc-4ff4-9312-22ab510d5f62︡{"hide":"input"}︡{"md":"\nThe command **factor** allows you to factor polynomials."}︡{"done":true}
︠a7bb43c1-c379-4c63-9947-48c096cc7f4a︠

factor(a^2 + 5*a + 6)
︡8f4a3bba-cba5-4b3a-83d1-e38a79542169︡{"stdout":"(a + 3)*(a + 2)\n"}︡{"done":true}
︠7fe36938-8282-4c61-93fc-b55ec931db60i︠
%hide
%md
${\bf Exercise\; 10.}$ Factor $x^2 + 7x + 6$.
︡9423f8b1-7375-4f04-afc4-6bce4b4338cd︡{"hide":"input"}︡{"md":"${\\bf Exercise\\; 10.}$ Factor $x^2 + 7x + 6$."}︡{"done":true}
︠b0533e66-2e24-4962-8f67-0d76df545b11s︠
factor(x^2+7*x+6)
︡808521e1-17a9-487e-a358-cfe76bb1d813︡{"stdout":"(x + 6)*(x + 1)\n"}︡{"done":true}
︠db584545-c563-4060-9d88-9e3cd2fbee28i︠
%hide
%md
${\bf Exercise\; 11.}$ Factor $k^2 - 5k + 6.$
︡a0cf40f9-1570-4e60-bd7d-1eb8d9eb8cf0︡{"hide":"input"}︡{"md":"${\\bf Exercise\\; 11.}$ Factor $k^2 - 5k + 6.$"}︡{"done":true}
︠b1d6b1ad-e34d-4598-a07a-0a0aa811fd00s︠
var('k')
factor(k^2-5*k+6)
︡ce81489c-f692-42b5-a5f2-2df4246e0f05︡{"stdout":"k\n"}︡{"stdout":"(k - 2)*(k - 3)\n"}︡{"done":true}
︠afb165f9-0736-405e-9f94-eed5b9426782i︠

%hide
%md
Plotting uses symbolic variables, so if you want to plot a function of a variable
other than $x$, you have to declare it before using it.
︡8e736b1b-ca7f-464f-8636-3ba586b5f692︡{"hide":"input"}︡{"md":"Plotting uses symbolic variables, so if you want to plot a function of a variable\nother than $x$, you have to declare it before using it."}︡{"done":true}
︠6b5d5b35-c2ff-4f17-b430-173038211976︠
var("p")
plot(log(p), (p,0,4))
︡dcdbbe10-6af8-48da-b765-40aa141acef8︡{"stdout":"p\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-9999b3ee-10e8-430f-9e36-b730d9d921b4/1110/tmp_FgdkdI.svg","show":true,"text":null,"uuid":"f0146c1d-b08a-44f8-a9fb-63a27fdde486"},"once":false}︡{"done":true}
︠fdf28e0d-2385-46aa-b7ee-a0fe1f1c2a23i︠
%hide
%md
${\bf Exercise\; 12.}$ Plot the function $f(n) = 2^n$ using $n$ as the independent variable, for values of $n$ between -30 and 30.
You don’t need to define the function before plotting it.
︡bb77803e-c94e-4cd2-972e-5ef1e02ea03f︡{"hide":"input"}︡{"md":"${\\bf Exercise\\; 12.}$ Plot the function $f(n) = 2^n$ using $n$ as the independent variable, for values of $n$ between -30 and 30.\nYou don’t need to define the function before plotting it."}︡{"done":true}
︠aac419af-4677-4b6f-b222-55ef46f57466s︠
var('n')
plot(2^n,(n,-30,30))
︡fdf87d74-ddf5-496f-bd20-7466383e287e︡{"stdout":"n\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/391/tmp_awM8uE.svg","show":true,"text":null,"uuid":"45678f65-39bb-47e1-9392-3d1fb1386a4b"},"once":false}︡{"done":true}
︠fdaea4db-80e9-450b-8dcf-a06d24633949i︠
%hide
%md
Once you assign a numeric value to a symbolic variable, it’s no longer a
symbolic variable. Instead, it’s now a number. A common plotting error results
from assigning a value to some variable, usually $x$, and later using that variable
in a plot. The tell-tale symptom of this problem is a graph consisting of one or
more horizontal lines.
︡e833fddb-5327-4888-ac8b-bc4c9120c681︡{"hide":"input"}︡{"md":"Once you assign a numeric value to a symbolic variable, it’s no longer a\nsymbolic variable. Instead, it’s now a number. A common plotting error results\nfrom assigning a value to some variable, usually $x$, and later using that variable\nin a plot. The tell-tale symptom of this problem is a graph consisting of one or\nmore horizontal lines."}︡{"done":true}
︠3b5242bc-5731-4d17-944d-6ad7fca21e60︠
x=2
plot(x^3, (x,-3,3), color="red")
︡762a995e-f32f-4a71-8f2a-13bc0f391b85︡{"file":{"filename":"/home/user/.sage/temp/project-9999b3ee-10e8-430f-9e36-b730d9d921b4/1110/tmp_QMs6wz.svg","show":true,"text":null,"uuid":"b5e5d4ae-464c-4b28-bc86-d75f1d4819ec"},"once":false}︡{"done":true}
︠7391e174-fba1-44a7-92ed-ebf0adc9753ci︠
%hide
%md
${\bf Exercise \;13.}$ Why is the horizontal line y=8 rather than some other value of
y?
︡bf37a945-cd22-4dfd-8f1f-5d31214f42f7︡{"hide":"input"}︡{"md":"${\\bf Exercise \\;13.}$ Why is the horizontal line y=8 rather than some other value of\ny?"}︡{"done":true}
︠69eaac9e-6064-46cd-b973-2ea83f73d6dc︠
#It's at 8 because the graph is zoomed in and when plugging the only/declared x-value into the equation which is 2 or aka (2^3), you get a set declared y-value of 8 aka the y-intercept.
︡de42c9f2-c24d-4940-b191-ae9b71b0b3e0︡
︠30526150-6bb2-420f-abdb-7679225e6e8ci︠
%hide
%md
To fix this problem, just declare $x$ to be a symbolic variable again.
︡4f2cf676-cf24-45af-88c4-4e280b44371e︡{"hide":"input"}︡{"md":"To fix this problem, just declare $x$ to be a symbolic variable again."}︡{"done":true}
︠c101b359-5c80-4c5c-9de1-abd4cb99cb33︠
var("x")
plot(x^3, (x,-3,3), color="red")
︡ba356498-31ec-470d-8638-b6dcfc726c27︡{"stdout":"x\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-9999b3ee-10e8-430f-9e36-b730d9d921b4/1110/tmp_T4eBdP.svg","show":true,"text":null,"uuid":"49d1a264-0483-4f3d-b766-e8af7ebaa5bc"},"once":false}︡{"done":true}
︠6fe81a8b-952b-482b-9914-995a006514da︠

︡48e772cf-a3e6-4c67-8421-5cacd684a282︡
︠f9571919-2e5b-4f4a-8d53-7f85c2afa31cis︠
%hide
%md
#  **-------------------Second Half of Lab 4--------------------------**.
## Curves and Lines

The rate of change of a function at a point has an important geometric meaning
that you will explore in this section. To do this, you’ll need to be able to plot
points, which is done with the command point.

${\bf Example 1.}$ To plot a point at the coordinates (1,2), use the command
 **point([1,2])**. Notice that the coordinates are given as a list.

${\bf Example 2.}$ To plot a larger red point at the coordinates (-3,5), use the command
**point([-3,5], color="red", size=40)**.

${\bf Exercise\; 14.}$ Plot the function $h(x) = 16x^2$ for values of x between 0 and 5.
Overlay the point (1,16) on the graph and make sure the point is visible.
︡f22812f3-f4cf-4181-bee0-bbf9a17ee5cf︡{"hide":"input"}︡{"md":"#  **-------------------Second Half of Lab 4--------------------------**.\n## Curves and Lines\n\nThe rate of change of a function at a point has an important geometric meaning\nthat you will explore in this section. To do this, you’ll need to be able to plot\npoints, which is done with the command point.\n\n${\\bf Example 1.}$ To plot a point at the coordinates (1,2), use the command\n **point([1,2])**. Notice that the coordinates are given as a list.\n\n${\\bf Example 2.}$ To plot a larger red point at the coordinates (-3,5), use the command\n**point([-3,5], color=\"red\", size=40)**.\n\n${\\bf Exercise\\; 14.}$ Plot the function $h(x) = 16x^2$ for values of x between 0 and 5.\nOverlay the point (1,16) on the graph and make sure the point is visible."}︡{"done":true}
︠b3bc1dbb-d67c-42d3-ae9f-7a1638e114f7s︠
pl=plot(16*x^2, (x,0,5))
p2=point([1,16],color="red",size=40)
show(pl+p2,axes_labels=["x","y"])
︡eac7ea2a-96bd-40c8-a419-383a6b5dbab8︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_A95eZs.svg","show":true,"text":null,"uuid":"8df39e9d-4fb0-4131-bac6-d64a215c9455"},"once":false}︡{"done":true}
︠22d3241a-ce46-4c44-a4c3-ce5ff86652a4i︠
%hide
%md
${\bf Exercise\; 15.}$ Create an animation that zooms in on this point by reducing the
range of $x$. Use at least five different zoom levels. What do you observe?
︡bd54d8b1-d0bd-49c1-a39d-99cd243ea8b2︡{"hide":"input"}︡{"md":"${\\bf Exercise\\; 15.}$ Create an animation that zooms in on this point by reducing the\nrange of $x$. Use at least five different zoom levels. What do you observe?"}︡{"done":true}
︠6e7f51e1-51ea-41da-9c77-7f49ad719694s︠
Frames=[]
dx=2
for ii in srange(0,12):
    p=plot(16*x^2,(x,1-dx,1+dx),axes_labels=["x","y"])+point([1,16],color="red",size=40)
    Frames.append(p)
    dx=dx/2.
    Ani=animate(Frames)
    show(Ani)
︡5c695d92-5092-4265-b3f6-008479976a05︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_MTqDIi.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_MTqDIi.webm"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_4NaiZI.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_4NaiZI.webm"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_ZcsUEf.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_ZcsUEf.webm"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_T7bsoc.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_T7bsoc.webm"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_eGltu2.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_eGltu2.webm"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_F6EOmr.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_F6EOmr.webm"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_XNi4Oi.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_XNi4Oi.webm"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_yBpS2s.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_yBpS2s.webm"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_oSOiNQ.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_oSOiNQ.webm"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_8yjwpo.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_8yjwpo.webm"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_wS5gOk.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_wS5gOk.webm"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_O4H8w5.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_O4H8w5.webm"},"once":false}︡{"done":true}
︠c535743b-ff38-4a91-a87f-1e6104e33f16i︠
%hide
%md
You should have noticed that as you zoom in on the curve, it starts to look
like a straight line. (Some points on certain curves will not do this, which is
an important observation but not very common in mathematical biology.) The
question is what straight line it is.

To answer this question, we want to plot lines with slopes corresponding to
the average rates of change we computed earlier. Since we have a point and a
slope, this is most easily done using the point-slope equation for a line passing
through the point $(x_1,y_1)$. This equation is $y-y_1 = m(x-x_1)$. However, since
Sage’s plot command requires everything other than y to be on the right-hand
side of the equation, we have to rearrange it into $y = m(x - x_1) + y_1$.

${\bf Exercise \;16.}$ Create an interactive that plots the function f(x) = $16x^2$ and
a line that passes through the point (1,16) and a second point on the function
whose $x$-coordinate is set by the slider. Describe what happens as the movable
point approaches the fixed one.
︡997241fe-6457-4e91-9136-5919f3e5f56a︡{"hide":"input"}︡{"md":"You should have noticed that as you zoom in on the curve, it starts to look\nlike a straight line. (Some points on certain curves will not do this, which is\nan important observation but not very common in mathematical biology.) The\nquestion is what straight line it is.\n\nTo answer this question, we want to plot lines with slopes corresponding to\nthe average rates of change we computed earlier. Since we have a point and a\nslope, this is most easily done using the point-slope equation for a line passing\nthrough the point $(x_1,y_1)$. This equation is $y-y_1 = m(x-x_1)$. However, since\nSage’s plot command requires everything other than y to be on the right-hand\nside of the equation, we have to rearrange it into $y = m(x - x_1) + y_1$.\n\n${\\bf Exercise \\;16.}$ Create an interactive that plots the function f(x) = $16x^2$ and\na line that passes through the point (1,16) and a second point on the function\nwhose $x$-coordinate is set by the slider. Describe what happens as the movable\npoint approaches the fixed one."}︡{"done":true}
︠04a004df-3754-4ec3-bc94-5672db58275es︠
f(x)=16*x^2
@interact
def plot_secant_line(x1=(0,2,1/50)):
    p1=plot(f(x),(x,0,5),axes_labels=["x","y"])
    p2=point([1,16],color="red",size=40)
    x0=1
    y0=(x0)
    y1=f(x1)
    m=(y1-y0)/(x1-x0)
    L(x)=y0+m*(x-x0)
    p3=point([x1,y1],color="blue",size=40)
    p4=plot(L(x),(x,0,5),color="green")
    show(p1+p2+p3+p4)
︡9e2aa486-4ce4-4678-bae9-42cb16ab3836︡{"interact":{"controls":[{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"x1","vals":["0","1/50","1/25","3/50","2/25","1/10","3/25","7/50","4/25","9/50","1/5","11/50","6/25","13/50","7/25","3/10","8/25","17/50","9/25","19/50","2/5","21/50","11/25","23/50","12/25","1/2","13/25","27/50","14/25","29/50","3/5","31/50","16/25","33/50","17/25","7/10","18/25","37/50","19/25","39/50","4/5","41/50","21/25","43/50","22/25","9/10","23/25","47/50","24/25","49/50","1","51/50","26/25","53/50","27/25","11/10","28/25","57/50","29/25","59/50","6/5","61/50","31/25","63/50","32/25","13/10","33/25","67/50","34/25","69/50","7/5","71/50","36/25","73/50","37/25","3/2","38/25","77/50","39/25","79/50","8/5","81/50","41/25","83/50","42/25","17/10","43/25","87/50","44/25","89/50","9/5","91/50","46/25","93/50","47/25","19/10","48/25","97/50","49/25","99/50","2"],"var":"x1","width":null}],"flicker":false,"id":"aa606403-2021-4d53-bbd8-63a13dff2f5c","layout":[[["x1",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}
︠95dfaf0e-92c8-4dc5-8df3-eb3b6efed9d6is︠
%hide
%md
${\bf Exercise \;17.}$ You can display a number on a plot using the text function. The
syntax to display the value val at point pt on a plot is **text(val, pt)**. (As in
other cases, you can give the coordinates of pt as a list.) Modify your interactive
so it computes and displays the slope of the line being plotted. **HINT:**  Use +
to overlay text on a plot.
︡8b0e77ca-ae67-420b-9c83-3db72a135049︡{"hide":"input"}︡{"md":"${\\bf Exercise \\;17.}$ You can display a number on a plot using the text function. The\nsyntax to display the value val at point pt on a plot is **text(val, pt)**. (As in\nother cases, you can give the coordinates of pt as a list.) Modify your interactive\nso it computes and displays the slope of the line being plotted. **HINT:**  Use +\nto overlay text on a plot."}︡{"done":true}
︠6c3c4276-ab01-4e21-8137-31d98fb81630s︠
f(x)=16*x^2
@interact
def plot_secant_line(x1=(0,2,1/50.)):
    p1=plot(f(x),(x,0,5),axes_labels=["x","y"])
    p2=point([1,16],color="red",size=40)
    x0=1
    y0=f(x)
    y1=f(x1)
    m=(y1-y0)/(x1-x0)
    L(x)=y0+m*(x-x0)
    p3=point([x1,y1],color="blue",size=40)
    p4=plot(L(x0),(x,0,5),color="green")
    p5=text("slope=",(0.3,100))+text(m,(1,100))
    show(p1+p2+p3+p4+p5)
︡a165d3f8-ec56-4e90-b415-f53862c2d8f8︡{"interact":{"controls":[{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"x1","vals":["0.000000000000000","0.0200000000000000","0.0400000000000000","0.0600000000000000","0.0800000000000000","0.100000000000000","0.120000000000000","0.140000000000000","0.160000000000000","0.180000000000000","0.200000000000000","0.220000000000000","0.240000000000000","0.260000000000000","0.280000000000000","0.300000000000000","0.320000000000000","0.340000000000000","0.360000000000000","0.380000000000000","0.400000000000000","0.420000000000000","0.440000000000000","0.460000000000000","0.480000000000000","0.500000000000000","0.520000000000000","0.540000000000000","0.560000000000000","0.580000000000000","0.600000000000000","0.620000000000000","0.640000000000000","0.660000000000000","0.680000000000000","0.700000000000000","0.720000000000000","0.740000000000000","0.760000000000000","0.780000000000000","0.800000000000000","0.820000000000000","0.840000000000000","0.860000000000000","0.880000000000000","0.900000000000000","0.920000000000000","0.940000000000001","0.960000000000001","0.980000000000001","1.00000000000000","1.02000000000000","1.04000000000000","1.06000000000000","1.08000000000000","1.10000000000000","1.12000000000000","1.14000000000000","1.16000000000000","1.18000000000000","1.20000000000000","1.22000000000000","1.24000000000000","1.26000000000000","1.28000000000000","1.30000000000000","1.32000000000000","1.34000000000000","1.36000000000000","1.38000000000000","1.40000000000000","1.42000000000000","1.44000000000000","1.46000000000000","1.48000000000000","1.50000000000000","1.52000000000000","1.54000000000000","1.56000000000000","1.58000000000000","1.60000000000000","1.62000000000000","1.64000000000000","1.66000000000000","1.68000000000000","1.70000000000000","1.72000000000000","1.74000000000000","1.76000000000000","1.78000000000000","1.80000000000000","1.82000000000000","1.84000000000000","1.86000000000000","1.88000000000000","1.90000000000000","1.92000000000000","1.94000000000000","1.96000000000000","1.98000000000000","2.00000000000000"],"var":"x1","width":null}],"flicker":false,"id":"d27b043e-42d2-4e38-85ca-3c0b1ddb869c","layout":[[["x1",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}
︠924ce4d8-07a7-4f89-80b9-af4bb733d188i︠
%hide
%md
${\bf Exercise\; 18.}$ Modify your interactive to also compute and display the derivative
of the function at the point (1,16) (NOT the point moved by the slider).
What do you notice about the derivative of the function and the slope of the
plotted line?
︡95d555af-0769-49e9-a466-69a31fb1bed9︡{"hide":"input"}︡{"md":"${\\bf Exercise 18.}$ Modify your interactive to also compute and display the derivative\nof the function at the point (1,16) (NOT the point moved by the slider).\nWhat do you notice about the derivative of the function and the slope of the\nplotted line?"}︡{"done":true}
︠ac09688f-4209-4589-a78b-1c0a6772ad81s︠
f(x)=16*x^2
df(x)=32*x
@interact
def plot_secant_line(x1=(0,2,1/50.)):
    p1=plot(f(x),(x,0,5),axes_labels=["x","y"])
    p2=point([1,16],color="red",size=40)
    x0=1
    y0=f(x0)
    y1=f(x1)
    m=(y1-y0)/(x1-x0)
    L(x)=y0+m*(x-x0)
    p3=point([x1,y1],color="blue",size=40)
    p4=plot(L(x),(x,0,5),color="green")
    p5=text("slope=",(0.3,100))+text(m,(1,100))
    p6=text("f'(1)=",(0.5,150))+text(df(1),(.75,150))
    show(p1+p2+p3+p4+p5+p6)
︡6f9e730f-37ea-4d74-9163-adfcc84754a9︡{"interact":{"controls":[{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"x1","vals":["0.000000000000000","0.0200000000000000","0.0400000000000000","0.0600000000000000","0.0800000000000000","0.100000000000000","0.120000000000000","0.140000000000000","0.160000000000000","0.180000000000000","0.200000000000000","0.220000000000000","0.240000000000000","0.260000000000000","0.280000000000000","0.300000000000000","0.320000000000000","0.340000000000000","0.360000000000000","0.380000000000000","0.400000000000000","0.420000000000000","0.440000000000000","0.460000000000000","0.480000000000000","0.500000000000000","0.520000000000000","0.540000000000000","0.560000000000000","0.580000000000000","0.600000000000000","0.620000000000000","0.640000000000000","0.660000000000000","0.680000000000000","0.700000000000000","0.720000000000000","0.740000000000000","0.760000000000000","0.780000000000000","0.800000000000000","0.820000000000000","0.840000000000000","0.860000000000000","0.880000000000000","0.900000000000000","0.920000000000000","0.940000000000001","0.960000000000001","0.980000000000001","1.00000000000000","1.02000000000000","1.04000000000000","1.06000000000000","1.08000000000000","1.10000000000000","1.12000000000000","1.14000000000000","1.16000000000000","1.18000000000000","1.20000000000000","1.22000000000000","1.24000000000000","1.26000000000000","1.28000000000000","1.30000000000000","1.32000000000000","1.34000000000000","1.36000000000000","1.38000000000000","1.40000000000000","1.42000000000000","1.44000000000000","1.46000000000000","1.48000000000000","1.50000000000000","1.52000000000000","1.54000000000000","1.56000000000000","1.58000000000000","1.60000000000000","1.62000000000000","1.64000000000000","1.66000000000000","1.68000000000000","1.70000000000000","1.72000000000000","1.74000000000000","1.76000000000000","1.78000000000000","1.80000000000000","1.82000000000000","1.84000000000000","1.86000000000000","1.88000000000000","1.90000000000000","1.92000000000000","1.94000000000000","1.96000000000000","1.98000000000000","2.00000000000000"],"var":"x1","width":null}],"flicker":false,"id":"6cb2374e-d9b6-47e1-a7e1-94faf371614f","layout":[[["x1",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}
︠ff99e201-625f-46bf-821e-5315f771f3e2is︠
%hide
%md
So far, we’ve been working with derivatives at single points. However, we
can compute the derivative of a function at all points on the function. We then
obtain a new function, $f'(x)$. Just like the number that gives the rate of change
of a function at a single point, $f'(x)$ is termed the derivative of $f(x)$.

In Sagemath, derivatives are computed using the function **diff**. For example, to
find the derivative of $e^{3x}$ with respect to $x$, enter  **diff(e^(3*x),x)**. The **diff**
function outputs a symbolic expression into which you can substitute numbers. If you would prefer to
have a function as the answer, use **fp(x)=diff(e^(3*x),x)**.

${\bf Example \;3.}$ What is the derivative of $f(x) = 5x^{16}$ at $x = 1.5$?
︡7e599302-ad20-4f60-b63b-be1b773d2029︡︡{"md":"So far, we’ve been working with derivatives at single points. However, we\ncan compute the derivative of a function at all points on the function. We then\nobtain a new function, $f'(x)$. Just like the number that gives the rate of change\nof a function at a single point, $f'(x)$ is termed the derivative of $f(x)$.\n\nIn Sagemath, derivatives are computed using the function **diff**. For example, to\nfind the derivative of $e^{3x}$ with respect to $x$, enter  **diff(e^(3*x),x)**. The **diff**\nfunction outputs a symbolic expression into which you can substitute numbers. If you would prefer to\nhave a function as the answer, use **fp(x)=diff(e^(3*x),x)**.\n\n${\\bf Example \\;3.}$ What is the derivative of $f(x) = 5x^{16}$ at $x = 1.5$?"}︡{"done":true}
︠eaef4087-f5a6-4086-a83a-1024416be93a︠
df = diff(5*x^16, x)
df

︡ca9ee47f-890e-42f6-9892-b9392d4185c8︡{"stdout":"80*x^15\n"}︡{"done":true}
︠91fd1339-2edd-4d3f-86e6-10d42a200999s︠
df.subs(x=1.5)
︡fcdc3fdf-704e-4e25-96a0-5ea9b370d453︡{"stdout":"35031.5112304688\n"}︡{"done":true}
︠58aff727-6bc1-490b-9fb9-a0879becd61cs︠
fp(x)=df
fp(1.5)

︡4a85b9aa-3031-481e-8ae2-384130573f25︡{"stdout":"35031.5112304688\n"}︡{"done":true}
︠780709ed-04f3-457e-8015-d2379a401604i︠
%hide
%md
${\bf Exercise\; 19.}$ Use diff to create an animation showing the
tangent line to a function at different points, like the one at
<http://en.wikipedia.org/wiki/File:Graph_of_sliding_derivative_line.gif>.
(You don’t need to make the line change color.)
︡cd2d5f1b-9a37-44b1-9587-63e31c637475︡{"hide":"input"}︡{"md":"${\\bf Exercise\\; 19.}$ Use diff to create an animation showing the\ntangent line to a function at different points, like the one at\n<http://en.wikipedia.org/wiki/File:Graph_of_sliding_derivative_line.gif>.\n(You don’t need to make the line change color.)"}︡{"done":true}
︠fc0d6531-cb23-4c9b-ad5a-28750aa1bccds︠
list_frame=[]
for x1 in srange (0,30,.5):
    df=diff(tan(x),x)
    m=df(x1)
    L(x)=m*(x-x1)+tan(x1)
    p= plot(tan(x), (x,0,30), ymin=-5, ymax=5)+point((x1,tan(x1)), size=40)+ plot(L(x), (x,x1-5,x1+5))
    list_frame.append(p)
ani=animate(list_frame)
show(ani)
︡690a3aad-9b8d-4dcd-9b2b-70a3af8b9acd︡{"file":{"filename":"/home/user/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_ASxnLl.webm","show":true,"text":null,"url":"/a608a444-3442-4899-a8f2-d88bc508e1e4/raw/.sage/temp/project-a608a444-3442-4899-a8f2-d88bc508e1e4/698/tmp_ASxnLl.webm"},"once":false}︡{"done":true}
︠b7f394ad-c61f-40ee-938a-2feb5865c237︠









